package com.tongda.tdpimssdk.api;

import com.alibaba.fastjson.JSONObject;
import com.tongda.tdpimssdk.auth.SaAuth;
import com.tongda.tdpimssdk.entities.Product;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.resultVo.vo.AssetVo;

import java.util.List;

public class PimsAsset {

    /**
     * 新建资产
     * @param vo
     * @return
     */
    public String pimsTemplate(AssetVo vo){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPost(url,(JSONObject)JSONObject.toJSON(vo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     * 查询资产详情
     * @param id
     * @return
     */
    public List<Product> getAssetContent(String id) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/details?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.sendGet(url);
        String s=PimsQuery.resultUtil(response);
        return JSONObject.parseArray(s,Product.class);
    }

    /**
     * 修改资产或文档属性(字段)
     * @param vo
     * @return
     */
    public String updateMetadataValues(AssetVo vo) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/field?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPut(url,(JSONObject)JSONObject.toJSON(vo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     *  删除资产
     * @param id
     * @return
     */
    public String deleteAsset(String id)  {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.sendDelete(url);
        String s=PimsQuery.resultUtil(response);
        return s;
    }


    public static String update="{\n" +
            "  \"id\": \"Product-1129487294932189184\",\n" +
            "  \"fields\": [\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_data_center\",\n" +
            "      \"value\": \"北京一区\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    }\n" +
            "  ]\n" +
            "}";
    public static String create="{\n" +
            "  \"templateID\": \"ProductTemplate-1110986502562643968\",\n" +
            "  \"label\": \"安全设备\",\n" +
            "  \"fields\": [\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_number\",\n" +
            "      \"value\": \"test\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_name\",\n" +
            "      \"value\": \"test\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_subtype\",\n" +
            "      \"value\": \"安全设备\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_serial_number\",\n" +
            "      \"value\": \"test\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_belong_project\",\n" +
            "      \"value\": \"test\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_desc\",\n" +
            "      \"value\": \"test\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_data_center\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_brand\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_device_manufacturer\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_model\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"tdpim.dict.custom.uom.power.watt\",\n" +
            "      \"key\": \"rated_total_power\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"tdpim.dict.custom.uom.quantity.u\",\n" +
            "      \"key\": \"device_u\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_usage\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"asset_ownership_epartment\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"responsible_department\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"responsible_person_name\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"responsible_person_phone\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"responsible_person_email\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_procurement_get_method\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_purchase_quantity\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"tdpim.dict.custom.uom.td_currency.cny.yuan\",\n" +
            "      \"key\": \"td_purchase_price\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"tdpim.dict.custom.uom.td_currency.cny.yuan\",\n" +
            "      \"key\": \"td_purchase_amount\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"acquisition_date\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"original_contact_person\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"original_contact_factory\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"original_contact_phone\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"storage_warehouse\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"aircraft_building\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"machine_room\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"cabinet_number\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"service_area\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"service_start_date\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"operating_system\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"firmware_version\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"in_band_ip\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"out_band_ip\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"business_ip\",\n" +
            "      \"value\": \"\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    }\n" +
            "  ]\n" +
            "}";



}
