package com.tongda.tdpimssdk.api;

import com.alibaba.fastjson.JSONObject;
import com.tongda.tdpimssdk.auth.SaAuth;
import com.tongda.tdpimssdk.entities.Product;
import com.tongda.tdpimssdk.entities.common.CatalogRoot;
import com.tongda.tdpimssdk.entities.common.Team2;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.resultVo.vo.AssetVo;
import com.tongda.tdpimssdk.resultVo.vo.CatalogItem;
import com.tongda.tdpimssdk.resultVo.vo.TeamVo;

import java.util.List;

public class PimsBusiness {

    /**
     * 新建业务
     * @param teamVo
     * @return
     */
    public String createBusiness(TeamVo teamVo){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPost(url,(JSONObject)JSONObject.toJSON(teamVo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     * 查询业务详情
     * @param id
     * @return
     */
    public List<Team2> getBusinessDetails(String id) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business/details?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.sendGet(url);
        String s=PimsQuery.resultUtil(response);
        return JSONObject.parseArray(s,Team2.class);
    }

    /**
     * 查询目录下资产列表
     * @param id
     * @return
     */
    public List<CatalogRoot> queryAssetByCatalog(String id, String catalogID) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business/details?dbName="+SaAuth.dbName+"&id="+id+"&catalogID="+catalogID;
        String response= PimHttpUtil.sendGet(url);
        String s=PimsQuery.resultUtil(response);
        return JSONObject.parseArray(s,CatalogRoot.class);
    }

    /**
     * 修改资产或文档属性(字段)
     * @param vo
     * @return
     */
    public String getLifeCycleDefinitionList(AssetVo vo) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/field?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPut(url,(JSONObject)JSONObject.toJSON(vo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     *  删除业务
     * @param id
     * @return
     */
    public String deleteTeam(String id)  {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business?dbName="+SaAuth.dbName;
        TeamVo teamVo=new TeamVo();
        teamVo.setTeamID(id);
        String response= PimHttpUtil.sendDeleteBody(url,(JSONObject)JSONObject.toJSON(teamVo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     *  将资源从业务团队中移除
     *  {
     *     "dbName": "TXPIMDB",
     *     "id": "Team2-1125463491344334848",
     *     "assetID": "Product-1125819770889830400"
     * }

     * @return
     */
    public String removeAssetFromTeam(CatalogItem item)  {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business/asset?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendDeleteBody(url,(JSONObject)JSONObject.toJSON(item));
        String s=PimsQuery.resultUtil(response);
        return s;
    }


    /**
     * 修改资产或文档属性(字段)
     * @param item
     * @return
     */
    public String addAssetRefToTeam(CatalogItem item) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business/asset?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPut(url,(JSONObject)JSONObject.toJSON(item));
        String s=PimsQuery.resultUtil(response);
        return s;
    }



    public static String remove="{\n" +
            "    \"dbName\": \"TXPIMDB\",\n" +
            "    \"id\": \"Team2-1125463491344334848\",\n" +
            "    \"assetID\": \"Product-1126119026813042688\"\n" +
            "}";

    public static String create="{\n" +
            "  \"userId\": \"EndUser-1128343251971997696\",\n" +
            "  \"label\": \"test16\",\n" +
            "  \"desc\": \"test\",\n" +
            "  \"lifecycleID\": \"TDLifeCycleDefinition-Common\"\n" +
            "}";


}
