package com.tongda.tdpimssdk.api;

import com.alibaba.fastjson.JSONObject;
import com.tongda.tdpimssdk.auth.SaAuth;
import com.tongda.tdpimssdk.entities.Product;
import com.tongda.tdpimssdk.entities.Resource;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.resultVo.vo.AssetVo;

import java.io.File;
import java.util.List;

public class PimsDocument {

    /**
     * 新建文档
     * @param vo
     * @return
     */
    public String createDocumentAsset(AssetVo vo){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/document?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPost(url,(JSONObject)JSONObject.toJSON(vo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     * 查询文档详情
     * @param id
     * @return
     */
    public List<Resource> getDocumentContent(String id) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/document/content?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.sendGet(url);
        String s=PimsQuery.resultUtil(response);
        return JSONObject.parseArray(s,Resource.class);
    }

    /**
     * 修改资产或文档属性(字段)
     * @param vo
     * @return
     */
    public String getLifeCycleDefinitionList(AssetVo vo) {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/document/field?dbName="+SaAuth.dbName;
        String response= PimHttpUtil.sendPut(url,(JSONObject)JSONObject.toJSON(vo));
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     * 删除文档
     * @param id
     * @return
     */
    public String deleteAsset(String id)  {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/document?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.sendDelete(url);
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    /**
     * 上传文档
     * @param id
     * @param file
     * @return
     */
    public String uploadBinary(String id, File file)  {
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/document/upload?dbName="+SaAuth.dbName+"&id="+id;
        String response= PimHttpUtil.uploadFile(url,file);
        String s=PimsQuery.resultUtil(response);
        return s;
    }

    public static String update="{\n" +
            "  \"id\": \"Resource-1129783425285226496\",\n" +
            "  \"fields\": [\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_number\",\n" +
            "      \"value\": \"test1234\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    }\n" +
            "  ]\n" +
            "}";

    public static String create="{\n" +
            "  \"templateID\": \"ResourceTemplate-1125740648473821184\",\n" +
            "  \"label\": \"测试7\",\n" +
            "  \"fields\": [\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_number\",\n" +
            "      \"value\": \"test123456789\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    },\n" +
            "    {\n" +
            "      \"mode\": \"tdpim.dict.system.metadata.mode.single.select.value\",\n" +
            "      \"uom\": \"\",\n" +
            "      \"key\": \"td_asset_subtype\",\n" +
            "      \"value\": \"安全设备\",\n" +
            "      \"valueMin\": null,\n" +
            "      \"valueMax\": null,\n" +
            "      \"selectedIDs\": null\n" +
            "    }\n" +
            "  ]\n" +
            "}";



}
