package com.tongda.tdpimssdk.api;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.tongda.tdpimssdk.auth.SaAuth;
import com.tongda.tdpimssdk.entities.AssetAbstract;
import com.tongda.tdpimssdk.entities.Entity;
import com.tongda.tdpimssdk.entities.common.CatalogRoot;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.resultVo.vo.GeneralPagerVo;

import java.util.List;

public class PimsQuery {

    /**
     * 查询资产模型清单
     * @return
     */
    public List<CatalogRoot> pimsTemplate(){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/template?dbName="+SaAuth.dbName;
        String response=PimHttpUtil.sendGet(url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,CatalogRoot.class);
    }

    /**
     * 查询文档模型清单
     * @return
     */
    public List<CatalogRoot> queryDocumentList(){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/template/document?dbName="+SaAuth.dbName;
        String response=PimHttpUtil.sendGet(url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,CatalogRoot.class);
    }

    /**
     * 根据模型ID查询资产/文档清单
     * @param templateID
     * @param page
     * @param size
     * @return
     */
    public GeneralPagerVo<AssetAbstract> getAssetByTemplate(String templateID, int page, int size){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset?dbName="+SaAuth.dbName+"&templateID="+templateID+"&page="+page+"&size="+size;
        String response=PimHttpUtil.sendGet(url);
        String s=resultUtil(response);
        return JSONObject.parseObject(s,new TypeReference<GeneralPagerVo<AssetAbstract>>(){});
    }

    /**
     * 查询资产所属业务
     * @param id
     * @return
     */
    public List<Entity> queryAssetAppViewPath(String id){
        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/asset/business/path?dbName="+SaAuth.dbName+"&id="+id;
        String response=PimHttpUtil.sendGet(url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,Entity.class);
    }

    /**
     * 查询业务清单
     * @return
     */
    public List<Entity> getBusinessList(String label) {

        String url="http://"+ SaAuth.serverId +":"+SaAuth.serverPort+"/pims/business?dbName="+SaAuth.dbName+"&label="+label;
        String response=PimHttpUtil.sendGet(url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,Entity.class);
    }


    public static String resultUtil(String re){
        System.out.println(re);
        JSONObject jsonObject=JSONObject.parseObject(re);
        if (jsonObject.get("code").toString().equals("200")){
            return jsonObject.get("data").toString();
        }else {
            throw new RuntimeException("调用接口异常："+re);
        }

    }


}
