package com.tongda.tdpimssdk.remote;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.tongda.tdpimssdk.entities.AssetAbstract;
import com.tongda.tdpimssdk.entities.Entity;
import com.tongda.tdpimssdk.entities.common.CatalogRoot;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.resultVo.vo.GeneralPagerVo;

import java.util.List;

public class RemoteTdPimHelper {

    RemoteSaAuthHandler rsh;
    public RemoteTdPimHelper(RemoteSaAuthHandler rsh){
        this.rsh  = rsh;
    }
    /**
     * 查询资产模型清单
     * @return
     */
    public CatalogRoot fetchAssetTemplates(){
        String url="http://"+ this.rsh.serverIP +":"+ this.rsh.serverPort+"/pims/template?dbName="+ this.rsh.dbName;
        String response= PimHttpUtil.sendGet(this.rsh.saToken, url);
        String s=resultUtil(response);
        List<CatalogRoot> catList =  JSONObject.parseArray(s,CatalogRoot.class);
        if(catList.size() == 1){
            return catList.get(0);
        }
        return null;
    }

    /**
     * 查询文档模型清单
     * @return
     */
    public CatalogRoot fetchDocumentTemplates(){
        String url="http://"+  this.rsh.serverIP +":"+ this.rsh.serverPort+"/pims/template/document?dbName="+ this.rsh.dbName;
        String response=PimHttpUtil.sendGet(this.rsh.saToken, url);
        String s=resultUtil(response);
        List<CatalogRoot> catList =  JSONObject.parseArray(s,CatalogRoot.class);
        if(catList.size() == 1){
            return catList.get(0);
        }
        return null;
    }

    /**
     * 根据模型ID查询资产/文档清单
     * @param templateID
     * @param page
     * @param size
     * @return
     */
    public GeneralPagerVo<AssetAbstract> fetchAssetByTemplate(String templateID, int page, int size){
        String url="http://"+ this.rsh.serverIP +":"+this.rsh.serverPort+"/pims/asset?dbName="+this.rsh.dbName+"&templateID="+templateID+"&page="+page+"&size="+size;
        String response=PimHttpUtil.sendGet(this.rsh.saToken, url);
        String s=resultUtil(response);
        return JSONObject.parseObject(s,new TypeReference<GeneralPagerVo<AssetAbstract>>(){});
    }


    /**
     * 查询资产所属业务
     * @param id
     * @return
     */
    public List<Entity> fetchAssetAppViewPath(String id){
        String url="http://"+  this.rsh.serverIP +":"+ this.rsh.serverPort+"/pims/asset/business/path?dbName="+ this.rsh.dbName+"&id="+id;
        String response=PimHttpUtil.sendGet(this.rsh.saToken,url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,Entity.class);
    }

    /**
     * 查询业务清单
     * @return
     */
    public List<Entity> fetchAppServiceList(String label) {

        String url="http://"+  this.rsh.serverIP +":"+ this.rsh.serverPort+"/pims/business?dbName="+ this.rsh.dbName+"&label="+label;
        String response=PimHttpUtil.sendGet(this.rsh.saToken, url);
        String s=resultUtil(response);
        return JSONObject.parseArray(s,Entity.class);
    }


    public void  createAsset(){

    }

    public void  deleteAsset(){

    }

    public RemoteAsset  fetchAsset(){
        return null;
    }



    public void  createDocument(){

    }

    public void deleteDocument(){

    }

    public RemoteDocument fetchDocument(){
        return null;
    }

    public void  createAppConfiguration(){

    }

    public void  createDeleteConfiguration(){

    }
    public RemoteAppConfiguration fetchAppConfiguration(){
        return null;
    }



    public static String resultUtil(String re){
      //  System.out.println(re);
        JSONObject jsonObject=JSONObject.parseObject(re);
        if (jsonObject.get("code").toString().equals("200")){
            return jsonObject.get("data").toString();
        }else {
            throw new RuntimeException("调用接口异常："+re);
        }

    }

}
